import { __assign } from './../external/tslib/tslib.es6.js';
import { useState } from 'react';
import { usePopper } from './../external/react-popper/lib/esm/usePopper.js';
import { popperGenerator, preventOverflow, popperOffsets, eventListeners, computeStyles, applyStyles, offset, flip } from '@popperjs/core';
import { useResizeDetector } from './../external/react-resize-detector/build/index.esm.js';
import useForkRef from './useForkRef.js';
var createPopper = popperGenerator({
  defaultModifiers: [preventOverflow, popperOffsets, eventListeners, computeStyles, applyStyles, __assign(__assign({}, offset), {
    options: {
      offset: [0, 6]
    }
  }), __assign(__assign({}, flip), {
    options: {
      fallbackPlacements: ['bottom-end', 'top-start', 'top-end']
    }
  })]
});

var useAutoPositioner = function (options) {
  if (options === void 0) {
    options = {};
  }

  var _a = useState(),
      popperReferenceElement = _a[0],
      setPopperReferenceElement = _a[1];

  var _b = useState(),
      popperElement = _b[0],
      setPopperElement = _b[1];

  var _c = usePopper(popperReferenceElement, popperElement, __assign(__assign({
    placement: 'bottom-start'
  }, options), {
    createPopper: createPopper
  })),
      styles = _c.styles,
      attributes = _c.attributes,
      update = _c.update;

  var onResize = function () {
    if (update) {
      update();
    }
  };

  var resizeRef = useResizeDetector({
    onResize: onResize,
    refreshRate: 100,
    refreshMode: 'debounce'
  }).ref;
  var setReferenceElement = useForkRef([setPopperReferenceElement, resizeRef]);
  return {
    setReferenceElement: setReferenceElement,
    setPopperElement: setPopperElement,
    styles: styles,
    attributes: attributes
  };
};

export { useAutoPositioner as default };
//# sourceMappingURL=useAutoPositioner.js.map
