import { useMemo } from 'react';

function setRef(ref, value) {
  if (typeof ref === 'function') {
    ref(value);
  } else if (ref) {
    // eslint-disable-next-line no-param-reassign
    ref.current = value;
  }
}

function useForkRef(refs) {
  return useMemo(function () {
    return function (refValue) {
      refs.forEach(function (ref) {
        return setRef(ref, refValue);
      });
    };
  }, [refs]);
}

export { useForkRef as default };
//# sourceMappingURL=useForkRef.js.map
